<h3 ng-if="!instance">
  Loading Instance details... <i class="fa fa-refresh fa-spin" aria-hidden="true"></i>
</h3>
<h3 ng-if="instance">
  {{ instance.name }}
</h3>

<div class="panel">
  <div class="row">
    <div class="large-10 columns">
      <ul class="instance-description">
        <li>LMS: <a href="{{ instance.url }}" target="_new">{{ instance.url }}</a></li>
        <li>Studio: <a href="{{ instance.studio_url }}" target="_new">{{ instance.studio_url }}</a></li>
      </ul>
    </div>
    <div class="large-2 columns">
      <span class="status radius label"
        ng-repeat="appserver in instance.active_appservers | orderBy: 'id'"
        ng-class="{warning: !appserver.is_healthy, success: appserver.is_healthy}"
        tooltip="{{ appserver.status_description }}">
        <i ng-attr-class="{{ appserver.is_steady && (appserver.is_healthy && 'fa fa-check' || 'fa fa-times') || 'fa fa-ellipsis-h' }}"></i>
        {{ appserver.name }}: {{ appserver.status_name }}
      </span>
      <span class="status radius label warning" ng-if="instance.active_appservers.length == 0">
        No active app server
      </span>
    </div>
  </div>
</div>

<div ng-if="showNotes">
  <div class="panel" ng-controller="Details" >
    <div class="row">
      <div class="large-12 columns">
        <h3>Notes <a ng-click="isEditingNotes=true"><i class="fa fa-edit"></i></a></h3>

        <div class="description">
          * Use this field only for backlinks of maintained instances. Otherwise, you can use it for temporary ephemeral notes, links to tickets with more information, etc.
        </div>

        <div ng-if="!isEditingNotes" ng-bind-html="render(instance.notes)"></div>

        <form name="editNotesForm" ng-if="isEditingNotes">
          <textarea rows="4" cols="50" ng-model="instance.notes">{{ instance.notes }}</textarea>
          <a ng-click="cancelEditNotes()">Cancel</a>
          <button class="btn btn-primary" type="submit" ng-click="editNotes()">Save</button>
        </form>
      </div>
    </div>
  </div>
</div>

<tabset>
  <tab heading="App Servers" active="instance_active_tabs.appservers_tab">
    <div class="row">
      <div class="large-3 columns">
        <h4>App Servers</h4>
        <button class="small" ng-click="spawn_appserver()" ng-disabled="is_spawning_appserver">
          <i class="fa fa-plus" ng-class="{'fa-spin': is_spawning_appserver}"></i> Launch new AppServer
        </button>
        <ul class="side-nav appserver-list">
          <li ng-if="instance.appservers.length < instance.appserver_count">
            <a ng-click='loadAllAppServers()'>(show all {{ instance.appserver_count }})</a>
          </li>

          <li ng-repeat="appserver in instance.appservers | orderBy: 'id'"
              ng-class="{'active-server': appserver.is_active,
                         active: appserver.id == state.params.appserverId}">
            <a ui-sref="instances.details.openedx_appserver_details({appserverId: appserver.id})">
              <i class="fa fa-server"></i> <span class="appserver-name">{{ appserver.name }}</span>
              <span ng-if="appserver.is_active">(Active)</span>
              <ul>
                <li>{{ appserver.status_name }}</li>
              </ul>
            </a>
          </li>
        </ul>
      </div>
      <div class="large-9 columns ui-view">
      <!-- AppServer details appear here -->
      </div>
    </div>
  </tab>
  <tab heading="Settings" active="instance_active_tabs.settings_tab">
    <h4>Current configuration <a href="{{ instance.admin_url }}"><i class="fa fa-pencil-square-o"></i></a></h4>
    <table>
      <thead>
        <tr>
          <th>Setting</th>
          <th>Value</th>
        </tr>
      </thead>
      <tbody>
        <tr><td>ID</td><td>{{ instance.id }}</td></tr>
        <tr><td>Name</td><td>{{ instance.name }}</td></tr>
        <tr><td>Created</td><td>{{ instance.created | date:'yyyy-MM-dd HH:mm:ssZ' }}</td></tr>
        <tr><td>Modified</td><td>{{ instance.modified | date:'yyyy-MM-dd HH:mm:ssZ' }}</td></tr>
        <tr><td>Type</td><td>{{ instance.instance_type }}</td></tr>
        <!-- The following are all specific to Open edX instances: -->
        <tr><td>LMS URL</td><td><a href="{{ instance.url}}">{{ instance.url}}</a></td></tr>
        <tr><td>Studio URL</td><td><a href="{{ instance.studio_url}}">{{ instance.studio_url}}</a></td></tr>
        <tr><td>Internal domain</td><td>{{ instance.internal_lms_domain }}</td></tr>
        <tr><td>HTTP auth username</td><td>{{ instance.http_auth_user }}</td></tr>
        <tr><td>HTTP auth password</td><td>{{ instance.http_auth_pass }}</td></tr>
        <tr><td>Load-balancing server</td><td>{{ instance.load_balancing_server }}</td></tr>
        <tr><td>Email</td><td>{{ instance.email }}</td></tr>
        <tr><td>Deploy simple_theme</td><td>{{ instance.deploy_simpletheme }}</td></tr>
        <tr><td>Creator (Ocim user)</td><td>{{ instance.creator_username }}</td></tr>
        <tr><td>Owner organization</td><td>{{ instance.owner_organization }}</td></tr>
        <tr><td>configuration_source_repo_url</td><td>{{ instance.configuration_source_repo_url }}</td></tr>
        <tr><td>configuration_version</td><td>{{ instance.configuration_version }}</td></tr>
        <tr><td>configuration_playbook_name</td><td>{{ instance.configuration_playbook_name }}</td></tr>
        <tr><td>edx_platform_repository_url</td><td>{{ instance.edx_platform_repository_url }}</td></tr>
        <tr><td>edx_platform_commit</td><td>{{ instance.edx_platform_commit }}</td></tr>
        <tr><td>Ansible appserver repo url</td><td>{{ instance.ansible_appserver_repo_url }}</td></tr>
        <tr><td>Ansible appserver playbook</td><td>{{ instance.ansible_appserver_playbook }}</td></tr>
        <tr><td>Ansible appserver requirements path</td><td>{{ instance.ansible_appserver_requirements_path }}</td></tr>
        <tr><td>Ansible appserver version</td><td>{{ instance.ansible_appserver_version }}</td></tr>
        <tr><td>openedx_release</td><td>{{ instance.openedx_release }}</td></tr>
        <tr><td>openstack_region</td><td>{{ instance.openstack_region }}</td></tr>
        <tr><td>openstack_server_flavor</td><td>{{ instance.openstack_server_flavor }}</td></tr>
        <tr><td>openstack_server_base_image</td><td>{{ instance.openstack_server_base_image }}</td></tr>
        <tr><td>openstack_server_ssh_keyname</td><td>{{ instance.openstack_server_ssh_keyname }}</td></tr>
        <tr><td>configuration_extra_settings</td><td><pre>{{ instance.configuration_extra_settings }}</pre></td></tr>
        <tr><td>configuration_theme_settings</td><td><pre>{{ instance.configuration_theme_settings }}</pre></td></tr>
        <tr><td>configuration_site_configuration_settings</td><td><pre>{{ instance.configuraton_site_configuration_settings }}</pre></td></tr>
        <tr><td>Additional security groups</td><td><pre>{{ instance.additional_security_groups }}</pre></td></tr>
        <tr><td>Additional monitoring email addresses</td><td>{{ instance.additional_monitoring_emails }}</td></tr>
        <tr><td>Email addresses monitoring AppServer provision failures</td><td>{{ instance.provisioning_failure_notification_emails }}</td></tr>
        <tr><td>Periodic builds enabled</td><td>{{ instance.periodic_builds_enabled }}</td></tr>
        <tr ng-if="instance.periodic_builds_enabled"><td>Periodic builds interval</td><td>{{ instance.periodic_builds_interval }}</td></tr>
        <tr ng-if="instance.periodic_builds_enabled"><td>Periodic builds retries</td><td>{{ instance.periodic_builds_retries }}</td></tr>
      </tbody>
    </table>

    <h4>Status</h4>
    <table>
      <tbody>
        <tr><td>MySQL provisioned</td><td>{{ instance.mysql_provisioned }}</td></tr>
        <tr><td>Mongo provisioned</td><td>{{ instance.mongo_provisioned }}</td></tr>
        <tr><td>RabbitMQ provisioned</td><td>{{ instance.rabbitmq_provisioned }}</td></tr>
        <tr><td>DNS records set at</td><td>{{ instance.dns_records_updated | date:'yyyy-MM-dd HH:mm:ssZ' }}</td></tr>
      </tbody>
    </table>
  </tab>
  <tab heading="Log" active="instance_active_tabs.log_tab">
    <p>This log does not include events from each App Server or VM. Select an App Server on the "App Servers" tab to view those logs.</p>
    <div ng-if="isFetchingLogs">
        Loading log...
    </div>
    <div ng-attr-class="instance-log {{ line.level | lowercase }}"
         ng-repeat="line in instanceLogs.log_entries track by $index">
      <span class="timestamp">{{ line.created | date:'yyyy-MM-dd HH:mm:ssZ' }}</span>
      <span class="log-level">{{ line.level }}</span>
      <pre>{{ line.text }}</pre>
    </div>
    <p ng-if="instance.log_entries.length == 0"><em>(There are currently no entries in this log)</em></p>
  </tab>
  <tab heading="Pull Request (#{{pr.github_pr_number}})" ng-if="instance.source_pr" ng-init="pr = instance.source_pr" active="instance_active_tabs.pr_tab">
    <h4>Pull Request Details</h4>
    <p>This instance was automatically generated for the GitHub pull request <a href="{{pr.github_pr_url}}">{{ pr.target_fork_name }} #{{ pr.github_pr_number }} ({{ pr.branch_name }})</a></p>

    <p>If the PR has changed, you can update the instance settings based on the PR:</p>
    <button ng-click="update_from_pr()" ng-disabled="is_updating_from_pr">
      <i class="fa fa-refresh" ng-class="{'fa-spin': is_updating_from_pr}"></i> Update Instance Settings from PR
    </button>

    <p>Note that this just updates the instance settings. You will still have to manually spawn a new App Server in order to deploy the changes.</p>

    <h4>Configuring this instance from the pull request</h4>

    <p>If you want to change the configuration for an instance generated from a PR, you can add or override any of its variables by adding a "Settings" section to your PR. This ensures the information is available in a central place, for both the reviewers and the OpenCraft Instance manager. The section should use the following format:</p>

    <div class="panel">
<pre>- - -
**Settings**
```yaml
[YAML: VARIABLES]
```</pre>
    </div>

    <p>For example:</p>

    <div class="panel">
<pre>- - -
**Settings**
```yaml
EDXAPP_FEATURES_EXTRA:
ALLOW_HIDING_DISCUSSION_TAB: true
```
</pre>
    </div>

    <p>Note: You need to match the above format exactly.</p>
  </tab>
  <tab heading="Pull Request (n/a)" ng-if="!(instance.source_pr)">
    <p>This instance was not created for a pull request.</p>
  </tab>
</tabset>
